gamemode_name <- "vsh2024";
::useDebugReload <- true && !IsDedicatedServer();
isVSH <- true;

function Mainload()
{
    if ("leftoverCustomCharacters" in ROOT)
    {
        foreach (player in leftoverCustomCharacters)
        {
            if (IsValidPlayer(player))
            {
                OnTickEnd(function(player)
                {
                    if (!IsValidPlayer(player))
                        PrintWarning(player);
                    else
                        player.SetHealth(player.GetMaxHealth());
                }, player)
            }
        }
    }
    ::leftoverCustomCharacters <- [];

    IncludeIfNot("_charlib/custom_character.nut", "CustomCharacter" in ROOT);
    OnGameEvent("post_inventory_application_post", 20, ProcessCustomCharacterInternal_PostInvApp);

    IncludeIfNot("_charlib/custom_weapon.nut", "CustomWeaponBase" in ROOT);
    IncludeIfNot("bosses/boss_base.nut", "BaseBossCharacter" in ROOT);
    IncludeIfNot("bosses/hale_character.nut", "SaxtonHaleBossCharacter" in ROOT);

    Include("_charlib/vcd_replacer.nut");
    //Include("bosses/mecha_hale/mecha_hale.nut")
    Include("vips/civilian_offhand_coin.nut")
    Include("vips/vip_shared.nut")
    Include("vips/vip_civilian.nut")
    Include("vips/vip_julius.nut")
    Include("vips/mobster/vip_mobster.nut")
    Include("of_merc/merc.nut")
    Include("mashup/mashup_gamemode.nut");
}

IncludeScript(gamemode_name + "/__lizardcore/_core.nut");
try { IncludeScript.call(this, gamemode_name + "/_debug/debug.nut"); } catch (e) { }
Include("debug2.nut");