::CustomWeaponMercAssaultRifle <- class extends CustomWeaponBase
{
    fakeRifle = null;

    function SpawnAssaultRifleBurster()
    {
        local fakeRifle = CreateByClassname("tf_weapon_smg");
        SetPropInt(fakeRifle, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 224);
        SetPropBool(fakeRifle, "m_AttributeManager.m_Item.m_bInitialized", true);
        SetPropEntity(fakeRifle, "m_hOwner", player);
        fakeRifle.DispatchSpawn();
        EntFireByHandle(fakeRifle, "SetParent", "!activator", -1, player, player);

        fakeRifle.AddAttribute("fire rate bonus HIDDEN", 1, 1);
        fakeRifle.AddAttribute("weapon spread bonus", 0.6, -1);
        fakeRifle.AddAttribute("clip size penalty HIDDEN", 1.22, -1);
        fakeRifle.AddAttribute("damage bonus HIDDEN", 2.8, -1);

        this.fakeRifle = fakeRifle;
        return fakeRifle;
    }

    function ShootAssaultRifleBurster()
    {
        SetPropFloat(fakeRifle, "m_flNextPrimaryAttack", Time() + 0.15);
        fakeRifle.SetClip1(min(2, weapon.Clip1()));

        player.ValidateScriptScope();
        player.GetScriptScope().ShootARPlayerThink <- ShootARPlayerThink.bindenv(this);
        AddThinkToEnt(player, "ShootARPlayerThink");
    }

    function ShootARPlayerThink()
    {
        if (!safeget(this, "fakeRifle", null) || fakeRifle.Clip1() <= 0 || !IsActive())
        {
            AddThinkToEnt(player, null);
            SetPropString(player, "m_iszScriptThinkFunction", "");
            return -1;
        }

        local clip = fakeRifle.Clip1();
        fakeRifle.PrimaryAttack();
        if (clip != fakeRifle.Clip1())
            weapon.SetClip1(weapon.Clip1() - 1);
        return -1;
    }

    function OnCleanup()
    {
        base.OnCleanup();
        AddThinkToEnt(player, null);
        SetPropString(player, "m_iszScriptThinkFunction", "");
    }
}