//!CompilePal::IncludeDirectory("materials/vip_mobster")
//!CompilePal::IncludeDirectory("models/vip_mobster")
//!CompilePal::IncludeDirectory("sound/vip_mobster")
//!CompilePal::IncludeDirectory("sound/mvm/mobster_t1")
//!CompilePal::IncludeDirectory("scripts/vscripts/mashup_2025")

gamemode_name <- "mashup_2025";
//::useDebugReload <- true && !IsDedicatedServer();
::useDebugReload <- true;

function Mainload()
{
    IncludeIfNot("_charlib/custom_character.nut", "CustomCharacter" in ROOT);
    InitCustomCharacterSystem();

    IncludeIfNot("_charlib/custom_weapon.nut", "CustomWeaponBase" in ROOT);
    IncludeIfNot("_charlib/projectile.nut", "ProjectileInfo" in ROOT);
    IncludeIfNot("_charlib/projectile_test.nut", "ProjectileInfo" in ROOT);
    IncludeIfNot("vip/characters/vip_shared.nut", "VIPShared" in ROOT);
    IncludeIfNot("vip/characters/civilian/civilian_offhand_coin.nut", "AbilityOffhandCoin" in ROOT);
    IncludeIfNot("vip/characters/civilian/vip_civilian.nut", "VIPCivilian" in ROOT);
    IncludeIfNot("vip/characters/civilian/vip_julius.nut", "VIPJulius" in ROOT);
    Include("vip/characters/merc_changes/vip_merc.nut");

    IncludeIfNot("vip/characters/mobster/vip_mobster.nut", "VIOPMobster" in ROOT);
    Include("_charlib/vcd_replacer.nut");

    Include("vip/gamemode/vip_gamemode.nut");
}

IncludeScript(gamemode_name + "/__lizardcore/_core.nut");
try { IncludeScript.call(this, gamemode_name + "/__lizardcore/debug.nut"); } catch (e) { }

OnDevCommand("julius", function(player, args)
{
    ConvertToCustomCharacter(FindPlayerByArgs(player, args), VIPJulius);
});

OnDevCommand("mobster", function(player, args)
{
    ConvertToCustomCharacter(FindPlayerByArgs(player, args), VIPMobster);
});

OnDevCommand("test", function(player, args)
{
    local scop = player.GetActiveWeapon();

    printl("scop "+scop)
    AddTimer(0.2, function()
    {
        printl(this + " " + safeget(this, "self", null));
    }, scop);
});

OnDevCommand("test2", function(player, args)
{
    foreach (ent in lizardTimers)
    {
        printl("a="+ent)
        ent[0]();
    }
});

OnDevCommand("test3", function(player, args)
{
    lizardTimers.clear();
});

OnDevCommand("test5", function(player, args)
{
    "player.GetActiveWeapon().SetModelSimple(`models/player/scout.mdl`)"
});

OnDevCommand("test4", function(player, args)
{
    local a, b;
    BeginBenchmark();
    for (local i = 0; i < 20; i++)
    {
        b = function()
        {
            return i;
        };
        a = b();
        //printl(a+" "+b)
    }
    local end = EndBenchmark();
    printl("test1: " + end);

    local b = function()
    {
        return player;
    };
    BeginBenchmark();
    for (local i = 0; i < 20; i++)
    {
        a = b();
        //printl(a+" "+b)
    }
    local end = EndBenchmark();
    printl("test2: " + end);

    /*BeginBenchmark();
    for (local i = 0; i < 10; i++)
        func.call(player);
    local end = EndBenchmark();
    printl("test2: " + end);

    BeginBenchmark();
    for (local i = 0; i < 10; i++)
        func2();
    local end = EndBenchmark();
    printl("test3: " + end);*/
});

OnDevCommand("respawn_cane", function(player, args)
{
    SpawnBlueCaneAt(args[0]);
});
