Include("of_merc/ar_stuff.nut");
PrecacheScriptSound("Weapon_AR.BoltForward");
PrecacheScriptSound("Weapon_AR.BoltBack");
PrecacheScriptSound("Weapon_AR.Single");

::MercenarySoundBank <- class extends SoundBank
{
    melee_kill = [
        "mvm/mercenary/mercenary_meleekill01.mp3"
    ]

    jump = [
        "mvm/mercenary/mercenary_jump01.mp3"
        "mvm/mercenary/mercenary_jump02.mp3"
        "mvm/mercenary/mercenary_jump03.mp3"
    ]

    battle_cry = [
        "mvm/mercenary/mercenary_battlecry01.mp3"
        "mvm/mercenary/mercenary_battlecry02.mp3"
        "mvm/mercenary/mercenary_battlecry03.mp3"
        "mvm/mercenary/mercenary_battlecry04.mp3"
        "mvm/mercenary/mercenary_battlecry05.mp3"
        "mvm/mercenary/mercenary_battlecry06.mp3"
    ]

    respawn = [
        "mvm/mercenary/mercenary_respawn01.mp3"
        "mvm/mercenary/mercenary_respawn02.mp3"
        "mvm/mercenary/mercenary_respawn03.mp3"
        "mvm/mercenary/mercenary_respawn04.mp3"
    ]

    on_fire = [
        "mvm/mercenary/mercenary_autoonfire01.mp3"
        "mvm/mercenary/mercenary_autoonfire02.mp3"
        "mvm/mercenary/mercenary_autoonfire03.mp3"
    ]

    cheers = [
        "mvm/mercenary/mercenary_cheers01.mp3"
        "mvm/mercenary/mercenary_cheers02.mp3"
        "mvm/mercenary/mercenary_cheers03.mp3"
        "mvm/mercenary/mercenary_cheers04.mp3"
        "mvm/mercenary/mercenary_cheers05.mp3"
        "mvm/mercenary/mercenary_cheers06.mp3"
    ]

    go = [
        "mvm/mercenary/mercenary_go01.mp3"
        "mvm/mercenary/mercenary_go02.mp3"
        "mvm/mercenary/mercenary_go03.mp3"
        "mvm/mercenary/mercenary_go04.mp3"
    ]

    good_job = [
        "mvm/mercenary/mercenary_goodjob01.mp3"
        "mvm/mercenary/mercenary_goodjob02.mp3"
        "mvm/mercenary/mercenary_goodjob03.mp3"
    ]

    head_left = [
        "mvm/mercenary/mercenary_headleft01.mp3"
        "mvm/mercenary/mercenary_headleft02.mp3"
        "mvm/mercenary/mercenary_headleft03.mp3"
    ]

    head_right = [
        "mvm/mercenary/mercenary_headright01.mp3"
        "mvm/mercenary/mercenary_headright02.mp3"
        "mvm/mercenary/mercenary_headright03.mp3"
    ]

    help = [
        "mvm/mercenary/mercenary_helpme01.mp3"
        "mvm/mercenary/mercenary_helpme02.mp3"
        "mvm/mercenary/mercenary_helpme03.mp3"
    ]

    incoming = [
        "mvm/mercenary/mercenary_incoming01.mp3"
        "mvm/mercenary/mercenary_incoming02.mp3"
        "mvm/mercenary/mercenary_incoming03.mp3"
        "mvm/mercenary/mercenary_incoming04.mp3"
    ]

    laugh_evil = [
        "mvm/mercenary/mercenary_laughevil01.mp3"
        "mvm/mercenary/mercenary_laughevil02.mp3"
        "mvm/mercenary/mercenary_laughevil03.mp3"
    ]

    laugh_happy = [
        "mvm/mercenary/mercenary_laughhappy01.mp3"
        "mvm/mercenary/mercenary_laughhappy02.mp3"
        "mvm/mercenary/mercenary_laughhappy03.mp3"
    ]

    laugh_long = [
        "mvm/mercenary/mercenary_laughevil01.mp3"
        "mvm/mercenary/mercenary_laughevil02.mp3"
        "mvm/mercenary/mercenary_laughevil03.mp3"
        "mvm/mercenary/mercenary_laughhappy01.mp3"
        "mvm/mercenary/mercenary_laughhappy02.mp3"
        "mvm/mercenary/mercenary_laughhappy03.mp3"
    ]

    move_up = [
        "mvm/mercenary/mercenary_moveup01.mp3"
        "mvm/mercenary/mercenary_moveup02.mp3"
        "mvm/mercenary/mercenary_moveup03.mp3"
    ]

    need_dispenser = [
        "mvm/mercenary/mercenary_needdispenser01.mp3"
    ]

    need_sentry = [
        "mvm/mercenary/mercenary_needsentry01.mp3"
    ]

    need_teleporter = [
        "mvm/mercenary/mercenary_needteleporter01.mp3"
    ]

    medic = [
        "mvm/mercenary/mercenary_medic01.mp3"
        "mvm/mercenary/mercenary_medic02.mp3"
        "mvm/mercenary/mercenary_medic03.mp3"
    ]

    negative = [
        "mvm/mercenary/mercenary_negativevocalization01.mp3"
        "mvm/mercenary/mercenary_negativevocalization02.mp3"
        "mvm/mercenary/mercenary_negativevocalization03.mp3"
        "mvm/mercenary/mercenary_negativevocalization04.mp3"
        "mvm/mercenary/mercenary_negativevocalization05.mp3"
        "mvm/mercenary/mercenary_negativevocalization06.mp3"
    ]

    nice_shot = [
        "mvm/mercenary/mercenary_niceshot01.mp3"
        "mvm/mercenary/mercenary_niceshot02.mp3"
        "mvm/mercenary/mercenary_niceshot03.mp3"
    ]

    no = [
        "mvm/mercenary/mercenary_no01.mp3"
        "mvm/mercenary/mercenary_no02.mp3"
        "mvm/mercenary/mercenary_no03.mp3"
    ]

    pain_critical_death = [
        "mvm/mercenary/mercenary_paincrticialdeath01.mp3"
        "mvm/mercenary/mercenary_paincrticialdeath02.mp3"
        "mvm/mercenary/mercenary_paincrticialdeath03.mp3"
        "mvm/mercenary/mercenary_paincrticialdeath04.mp3"
    ]

    pain_severe = [
        "mvm/mercenary/mercenary_painsevere01.mp3"
        "mvm/mercenary/mercenary_painsevere02.mp3"
        "mvm/mercenary/mercenary_painsevere03.mp3"
        "mvm/mercenary/mercenary_painsevere04.mp3"
        "mvm/mercenary/mercenary_painsevere05.mp3"
        "mvm/mercenary/mercenary_painsevere06.mp3"
    ]

    domination = [
        "mvm/mercenary/mercenary_domination01.mp3"
        "mvm/mercenary/mercenary_domination02.mp3"
        "mvm/mercenary/mercenary_domination03.mp3"
        "mvm/mercenary/mercenary_domination04.mp3"
        "mvm/mercenary/mercenary_domination05.mp3"
        "mvm/mercenary/mercenary_domination06.mp3"
    ]

    assist_sfx = [
        "Player.HitSoundElectro"
    ]

    respawn_sfx = [
        "Building_Teleporter.Receive"
    ]
}

::Mercenary <- class extends CustomCharacter
{
    soundBankClass = MercenarySoundBank;

    playerClass = TF_CLASS_SOLDIER;
    maxHealth = 150;
    deleteItems = true;
    mute = true;
    keepAfterDeath = false;
    keepAfterClassChange = false;

    weaponSuperShotgun = class extends CustomWeaponBase
    {
        baseclass   = "tf_weapon_scattergun";
        baseid      = 13;
        viewmodel   = "models/deathmatch/weapons/v_supershotgun.mdl";
        worldmodel  = "models/deathmatch/weapons/w_supershotgun.mdl";
        armsmodel   = "models/deathmatch/weapons/c_merc_arms.mdl";
        playermodel = "models/deathmatch/player/mercenary_ssg.mdl";

        clip        = 1;
        maxAmmo     = 16;
        mute        = true;

        function Precache()
        {
            PrecacheSound(")deathmatch/weapons/supershotgun_shoot.mp3");
        }

        function OnEquip()
        {
            weapon.AddAttribute("clip size penalty HIDDEN", 0.15, -1);
            weapon.AddAttribute("bullets per shot bonus", 2.06, -1);
            weapon.AddAttribute("fixed_shot_pattern", 1, -1);
            weapon.AddAttribute("Reload time increased", 0.8, -1);
        }

        function OnFire()
        {
            /*EmitSoundEx({
                sound_name = ")deathmatch/weapons/supershotgun_shoot.mp3",
                entity = player,
                channel = CHAN_STATIC,
                sound_level = 150,
                volume = 1,
            });*/
        }
    }

    weaponAssaultRifle = class extends CustomWeaponMercAssaultRifle
    {
        baseclass   = "tf_weapon_smg";
        baseid      = 224;
        viewmodel   = "models/deathmatch/weapons/v_assault_rifle.mdl";
        worldmodel  = "models/deathmatch/weapons/w_assault_rifle.mdl";
        armsmodel   = "models/deathmatch/weapons/c_merc_arms.mdl";
        playermodel = "models/deathmatch/player/mercenary_assaultrifle.mdl";

        clip = 30;
        maxAmmo = 90;
        mute = true;

        function Precache()
        {
            PrecacheSound(")deathmatch/weapons/assaultrifle_shoot.mp3");
        }

        function OnEquip()
        {
            SpawnAssaultRifleBurster();
            weapon.AddAttribute("fire rate bonus HIDDEN", 5.2, 1);
            weapon.AddAttribute("weapon spread bonus", 0.6, -1);
            weapon.AddAttribute("clip size penalty HIDDEN", 1.22, -1);
            weapon.AddAttribute("damage bonus HIDDEN", 2.8, -1);
            weapon.AddAttribute("Reload time increased hidden", 0.95, -1);
        }

        function OnFire()
        {
            ShootAssaultRifleBurster();
            //Shooting sounds only for other players
            for (local i = 0; i < 0.25; i += 0.07)
                RunWithDelay(i, function()
                {
                    local restore = NetProps.GetPropVector(player, "m_vecViewOffset");
                    SetPropVector(player, "m_vecViewOffset", Vector(999999, 999999, 999999));
                    EmitSoundEx({
                        sound_name = ")deathmatch/weapons/assaultrifle_shoot.mp3",
                        entity = player,
                        channel = CHAN_STATIC,
                        sound_level = 150,
                        volume = 1,
                    });
                    SetPropVector(player, "m_vecViewOffset", restore);
                });
        }
    }

    weaponCrowbar = class extends CustomWeaponBase
    {
        baseclass  = "tf_weapon_shovel";
        baseid     = 196;
        viewmodel  = "models/deathmatch/weapons/v_crowbar.mdl";
        armsmodel  = "models/deathmatch/weapons/c_merc_arms.mdl";
        worldmodel = "models/deathmatch/weapons/w_crowbar.mdl";

        function OnEquip()
        {
            weapon.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weapon.AddAttribute("damage penalty", 0.615, -1);
            weapon.AddAttribute("melee range multiplier", 1.15, -1);
            weapon.AddAttribute("melee bounds multiplier", 1.1, -1);
            weapon.AddAttribute("single wep deploy time increased", 1.3, -1);
        }
    }

    function Precache()
    {
        base.Precache();
    }

    function ApplyCharacter()
    {
        base.ApplyCharacter();

        player.AddCustomAttribute("cancel falling damage", 1, -1);
        player.AddCustomAttribute("crit mod disabled hidden", 0, -1);
        player.AddCustomAttribute("no double jump", 1, -1);
        player.AddCustomAttribute("cannot be backstabbed", 1, -1);

        //player.AddCustomAttribute("move speed bonus", 1.5, -1);
        player.AddCustomAttribute("move speed bonus", 3, -1);

        ProvideCustomWeapon(player, weaponSuperShotgun).Kill();
        player.Weapon_Switch(ProvideCustomWeapon(player, weaponSuperShotgun));
        ProvideCustomWeapon(player, weaponAssaultRifle);
        ProvideCustomWeapon(player, weaponCrowbar);
        if (player.GetTeam() == TF_TEAM_RED)
            SetEntityColor(player, [184, 56, 59, 255])
        else
            SetEntityColor(player, [88, 133, 162, 255])
    }

    function OnCleanup()
    {
        SetEntityColor(player, [255, 255, 255, 255])
        model = "";
    }
}
