SetPropInt(FindByClassname(null, "tf_gamerules"), "m_nHudType", 1);
SetPropInt(FindByClassname(null, "tf_gamerules"), "m_bPlayingHybrid_CTF_CP", 1);

class ::CompassController
{
    compassControllers = {};
    compass_target = null;
    flag_ent = null;

    constructor(compass_target)
    {
        compassControllers[this] <- compass_target;

        this.compass_target = compass_target;

        flag_ent = SpawnEntityFromTable("item_teamflag", {
            PointValue = 1,
            teamnum = compass_target.GetTeam(),
            flag_model = "models/empty.mdl",
            origin = compass_target.GetOrigin() - Vector(0, 0, 9999),
            GameType = 6
        });
        flag_ent.AcceptInput("SetParent", "!activator", compass_target, compass_target);
        SetPropInt(flag_ent, "m_nFlagStatus", 1);
    }

    function DestroyCompassController()
    {
        delete compassControllers[this];
        KillIfValid(flag_ent);
    }
}